#ifndef EDJE_OBJECT_EO_HH
#define EDJE_OBJECT_EO_HH
#include <Eo.h>

extern "C" {
#include "edje_object.eo.h"
#include "efl_animator.eo.h"
#include "efl_canvas_group.eo.h"
#include "efl_canvas_group_clipped.eo.h"
#include "efl_canvas_object.eo.h"
#include "efl_container.eo.h"
#include "efl_file.eo.h"
#include "efl_gfx.eo.h"
#include "efl_gfx_map.eo.h"
#include "efl_gfx_size_hint.eo.h"
#include "efl_gfx_stack.eo.h"
#include "efl_input_device.eo.h"
#include "efl_input_focus.eo.h"
#include "efl_input_hold.eo.h"
#include "efl_input_interface.eo.h"
#include "efl_input_key.eo.h"
#include "efl_input_pointer.eo.h"
#include "efl_interface.eo.h"
#include "efl_loop.eo.h"
#include "efl_loop_user.eo.h"
#include "efl_object.eo.h"
#include "efl_observer.eo.h"
#include "efl_part.eo.h"
#include "efl_ui_base.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_animator.eo.hh"
#include "efl_canvas_group.eo.hh"
#include "efl_canvas_group_clipped.eo.hh"
#include "efl_canvas_object.eo.hh"
#include "efl_container.eo.hh"
#include "efl_file.eo.hh"
#include "efl_gfx.eo.hh"
#include "efl_gfx_map.eo.hh"
#include "efl_gfx_size_hint.eo.hh"
#include "efl_gfx_stack.eo.hh"
#include "efl_input_device.eo.hh"
#include "efl_input_focus.eo.hh"
#include "efl_input_hold.eo.hh"
#include "efl_input_interface.eo.hh"
#include "efl_input_key.eo.hh"
#include "efl_input_pointer.eo.hh"
#include "efl_interface.eo.hh"
#include "efl_loop.eo.hh"
#include "efl_loop_user.eo.hh"
#include "efl_object.eo.hh"
#include "efl_observer.eo.hh"
#include "efl_part.eo.hh"
#include "efl_ui_base.eo.hh"
namespace edje { 
struct Object;
} 
namespace efl { namespace eo { template<> struct is_eolian_object< ::edje::Object> : ::std::true_type {}; } }
namespace edje { 
struct Object;
} 
namespace efl { namespace canvas { namespace group { 
struct Clipped;
} } } 
namespace efl { namespace canvas { 
struct Group;
} } 
namespace efl { namespace canvas { 
struct Object;
} } 
namespace efl { 
struct Object;
} 
namespace efl { 
struct Gfx;
} 
namespace efl { namespace gfx { 
struct Stack;
} } 
namespace efl { 
struct Animator;
} 
namespace efl { namespace input { 
struct Interface;
} } 
namespace efl { namespace input { 
struct Device;
} } 
namespace efl { namespace input { 
struct Pointer;
} } 
namespace efl { namespace input { 
struct Key;
} } 
namespace efl { namespace input { 
struct Hold;
} } 
namespace efl { namespace input { 
struct Focus;
} } 
namespace efl { namespace gfx { namespace size { 
struct Hint;
} } } 
namespace efl { namespace gfx { 
struct Map;
} } 
namespace efl { 
struct Interface;
} 
namespace efl { 
struct Loop_User;
} 
namespace efl { 
struct Loop;
} 
namespace efl { 
struct File;
} 
namespace efl { 
struct Container;
} 
namespace efl { 
struct Part;
} 
namespace efl { 
struct Observer;
} 
namespace efl { namespace ui { 
struct Base;
} } 

namespace eo_cxx {
namespace edje { 
struct Object {
   ::efl::eolian::return_traits<bool>::type animation_get() const;
   ::efl::eolian::return_traits<void>::type animation_set( ::efl::eolian::in_traits<bool>::type on) const;
   ::efl::eolian::return_traits<bool>::type play_get() const;
   ::efl::eolian::return_traits<void>::type play_set( ::efl::eolian::in_traits<bool>::type play) const;
   ::efl::eolian::return_traits<Edje_Perspective const&>::type perspective_get() const;
   ::efl::eolian::return_traits<void>::type perspective_set( ::efl::eolian::in_traits<Edje_Perspective const&>::type ps) const;
   ::efl::eolian::return_traits<double>::type transition_duration_factor_get() const;
   ::efl::eolian::return_traits<void>::type transition_duration_factor_set( ::efl::eolian::in_traits<double>::type scale) const;
   ::efl::eolian::return_traits<Efl_Image_Load_Error>::type load_error_get() const;
   ::efl::eolian::return_traits<bool>::type calc_update_hints_get() const;
   ::efl::eolian::return_traits<void>::type calc_update_hints_set( ::efl::eolian::in_traits<bool>::type update) const;
   ::efl::eolian::return_traits<void>::type group_size_min_get( ::efl::eolian::out_traits<int>::type minw,  ::efl::eolian::out_traits<int>::type minh) const;
   ::efl::eolian::return_traits<void>::type group_size_max_get( ::efl::eolian::out_traits<int>::type maxw,  ::efl::eolian::out_traits<int>::type maxh) const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type group_data_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type key) const;
   ::efl::eolian::return_traits<bool>::type global_color_class_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type color_class,  ::efl::eolian::in_traits<Edje_Color_Class_Mode>::type mode,  ::efl::eolian::out_traits<int>::type r,  ::efl::eolian::out_traits<int>::type g,  ::efl::eolian::out_traits<int>::type b,  ::efl::eolian::out_traits<int>::type a) const;
   ::efl::eolian::return_traits<bool>::type global_color_class_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type color_class,  ::efl::eolian::in_traits<Edje_Color_Class_Mode>::type mode,  ::efl::eolian::in_traits<int>::type r,  ::efl::eolian::in_traits<int>::type g,  ::efl::eolian::in_traits<int>::type b,  ::efl::eolian::in_traits<int>::type a) const;
   ::efl::eolian::return_traits<bool>::type color_class_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type color_class,  ::efl::eolian::in_traits<Edje_Color_Class_Mode>::type mode,  ::efl::eolian::out_traits<int>::type r,  ::efl::eolian::out_traits<int>::type g,  ::efl::eolian::out_traits<int>::type b,  ::efl::eolian::out_traits<int>::type a) const;
   ::efl::eolian::return_traits<bool>::type color_class_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type color_class,  ::efl::eolian::in_traits<Edje_Color_Class_Mode>::type mode,  ::efl::eolian::in_traits<int>::type r,  ::efl::eolian::in_traits<int>::type g,  ::efl::eolian::in_traits<int>::type b,  ::efl::eolian::in_traits<int>::type a) const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type color_class_description_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type color_class) const;
   ::efl::eolian::return_traits<bool>::type text_class_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type text_class,  ::efl::eolian::out_traits< ::efl::eina::string_view>::type font,  ::efl::eolian::out_traits<int>::type size) const;
   ::efl::eolian::return_traits<bool>::type text_class_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type text_class,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type font,  ::efl::eolian::in_traits<int>::type size) const;
   ::efl::eolian::return_traits<bool>::type size_class_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type size_class,  ::efl::eolian::out_traits<int>::type minw,  ::efl::eolian::out_traits<int>::type minh,  ::efl::eolian::out_traits<int>::type maxw,  ::efl::eolian::out_traits<int>::type maxh) const;
   ::efl::eolian::return_traits<bool>::type size_class_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type size_class,  ::efl::eolian::in_traits<int>::type minw,  ::efl::eolian::in_traits<int>::type minh,  ::efl::eolian::in_traits<int>::type maxw,  ::efl::eolian::in_traits<int>::type maxh) const;
   ::efl::eolian::return_traits<void>::type text_change_cb_set( ::efl::eolian::in_traits<Edje_Text_Change_Cb>::type func,  ::efl::eolian::in_traits<void*>::type data) const;
   ::efl::eolian::return_traits<Edje_Text_Autocapital_Type>::type part_text_autocapital_type_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   ::efl::eolian::return_traits<void>::type part_text_autocapital_type_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Text_Autocapital_Type>::type autocapital_type) const;
   ::efl::eolian::return_traits<bool>::type part_text_prediction_allow_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   ::efl::eolian::return_traits<void>::type part_text_prediction_allow_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<bool>::type prediction) const;
   ::efl::eolian::return_traits<void>::type item_provider_set( ::efl::eolian::in_traits<Edje_Item_Provider_Cb>::type func,  ::efl::eolian::in_traits<void*>::type data) const;
   ::efl::eolian::return_traits<void>::type part_text_select_allow_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<bool>::type allow) const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type part_text_selection_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   ::efl::eolian::return_traits<void*>::type part_text_imf_context_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   ::efl::eolian::return_traits<Edje_Input_Hints>::type part_text_input_hint_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   ::efl::eolian::return_traits<void>::type part_text_input_hint_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Input_Hints>::type input_hints) const;
   ::efl::eolian::return_traits<void>::type part_text_input_panel_imdata_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<void*>::type data,  ::efl::eolian::out_traits<int>::type len) const;
   ::efl::eolian::return_traits<void>::type part_text_input_panel_imdata_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<void const*>::type data,  ::efl::eolian::in_traits<int>::type len) const;
   ::efl::eolian::return_traits<Edje_Input_Panel_Layout>::type part_text_input_panel_layout_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   ::efl::eolian::return_traits<void>::type part_text_input_panel_layout_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Input_Panel_Layout>::type layout) const;
   ::efl::eolian::return_traits<Edje_Input_Panel_Lang>::type part_text_input_panel_language_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   ::efl::eolian::return_traits<void>::type part_text_input_panel_language_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Input_Panel_Lang>::type lang) const;
   ::efl::eolian::return_traits<int>::type part_text_input_panel_layout_variation_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   ::efl::eolian::return_traits<void>::type part_text_input_panel_layout_variation_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<int>::type variation) const;
   ::efl::eolian::return_traits<bool>::type part_text_input_panel_enabled_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   ::efl::eolian::return_traits<void>::type part_text_input_panel_enabled_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<bool>::type enabled) const;
   ::efl::eolian::return_traits<bool>::type part_text_input_panel_return_key_disabled_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   ::efl::eolian::return_traits<void>::type part_text_input_panel_return_key_disabled_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<bool>::type disabled) const;
   ::efl::eolian::return_traits<Edje_Input_Panel_Return_Key_Type>::type part_text_input_panel_return_key_type_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   ::efl::eolian::return_traits<void>::type part_text_input_panel_return_key_type_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Input_Panel_Return_Key_Type>::type return_key_type) const;
   ::efl::eolian::return_traits<bool>::type part_text_input_panel_show_on_demand_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   ::efl::eolian::return_traits<void>::type part_text_input_panel_show_on_demand_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<bool>::type ondemand) const;
   ::efl::eolian::return_traits<void>::type part_text_prediction_hint_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type prediction_hint) const;
   ::efl::eolian::return_traits< ::efl::input::Device>::type seat_get( ::efl::eolian::in_traits< ::efl::eina::stringshare>::type name) const;
   ::efl::eolian::return_traits< ::efl::eina::stringshare>::type seat_name_get( ::efl::eolian::in_traits< ::efl::input::Device>::type device) const;
   ::efl::eolian::return_traits<bool>::type preload( ::efl::eolian::in_traits<bool>::type cancel) const;
   ::efl::eolian::return_traits<void>::type size_min_calc( ::efl::eolian::out_traits<int>::type minw,  ::efl::eolian::out_traits<int>::type minh) const;
   ::efl::eolian::return_traits<void>::type size_min_restricted_calc( ::efl::eolian::out_traits<int>::type minw,  ::efl::eolian::out_traits<int>::type minh,  ::efl::eolian::in_traits<int>::type restrictedw,  ::efl::eolian::in_traits<int>::type restrictedh) const;
   ::efl::eolian::return_traits<bool>::type parts_extends_calc( ::efl::eolian::out_traits<int>::type x,  ::efl::eolian::out_traits<int>::type y,  ::efl::eolian::out_traits<int>::type w,  ::efl::eolian::out_traits<int>::type h) const;
   ::efl::eolian::return_traits<void>::type calc_force() const;
   ::efl::eolian::return_traits<int>::type calc_freeze() const;
   ::efl::eolian::return_traits<int>::type calc_thaw() const;
   ::efl::eolian::return_traits<void>::type message_send( ::efl::eolian::in_traits<int>::type id,  ::efl::eolian::in_traits< ::efl::eina::value_view const>::type msg) const;
   ::efl::eolian::return_traits<void>::type signal_callback_add( ::efl::eolian::in_traits< ::efl::eina::string_view>::type emission,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type source,  ::efl::eolian::in_traits<Edje_Signal_Cb>::type func,  ::efl::eolian::in_traits<void*>::type data) const;
   ::efl::eolian::return_traits<void*>::type signal_callback_del( ::efl::eolian::in_traits< ::efl::eina::string_view>::type emission,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type source,  ::efl::eolian::in_traits<Edje_Signal_Cb>::type func,  ::efl::eolian::in_traits<void*>::type data) const;
   ::efl::eolian::return_traits<void>::type signal_emit( ::efl::eolian::in_traits< ::efl::eina::string_view>::type emission,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type source) const;
   ::efl::eolian::return_traits<void>::type message_signal_process( ::efl::eolian::in_traits< ::efl::eina::optional<bool>>::type recurse) const;
   ::efl::eolian::return_traits<bool>::type color_class_clear() const;
   ::efl::eolian::return_traits<void>::type color_class_del( ::efl::eolian::in_traits< ::efl::eina::string_view>::type color_class) const;
   ::efl::eolian::return_traits<void>::type text_class_del( ::efl::eolian::in_traits< ::efl::eina::string_view>::type text_class) const;
   ::efl::eolian::return_traits<void>::type size_class_del( ::efl::eolian::in_traits< ::efl::eina::string_view>::type size_class) const;
   ::efl::eolian::return_traits< ::efl::eina::iterator< ::efl::eina::string_view>>::type access_part_iterate() const;
   ::efl::eolian::return_traits<bool>::type part_exists( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   ::efl::eolian::return_traits<void>::type part_text_select_begin( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   ::efl::eolian::return_traits<void>::type part_text_select_abort( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   ::efl::eolian::return_traits<void>::type part_text_select_extend( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   ::efl::eolian::return_traits<void>::type part_text_select_all( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   ::efl::eolian::return_traits<void>::type part_text_select_none( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   ::efl::eolian::return_traits<void>::type part_text_imf_context_reset( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   ::efl::eolian::return_traits<void>::type part_text_input_panel_show( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   ::efl::eolian::return_traits<void>::type part_text_input_panel_hide( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   static Efl_Class const* _eo_class()
   {
      return EDJE_OBJECT_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::edje::Object() const;
   operator ::edje::Object&();
   operator ::edje::Object const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Object,  ::efl::Animator,  ::efl::Container,  ::efl::File,  ::efl::Gfx,  ::efl::Interface,  ::efl::Loop_User,  ::efl::Object,  ::efl::Observer,  ::efl::Part,  ::efl::canvas::Group,  ::efl::canvas::Object,  ::efl::canvas::group::Clipped,  ::efl::gfx::Map,  ::efl::gfx::Stack,  ::efl::gfx::size::Hint,  ::efl::input::Interface,  ::efl::ui::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Object const ,  ::efl::Animator const ,  ::efl::Container const ,  ::efl::File const ,  ::efl::Gfx const ,  ::efl::Interface const ,  ::efl::Loop_User const ,  ::efl::Object const ,  ::efl::Observer const ,  ::efl::Part const ,  ::efl::canvas::Group const ,  ::efl::canvas::Object const ,  ::efl::canvas::group::Clipped const ,  ::efl::gfx::Map const ,  ::efl::gfx::Stack const ,  ::efl::gfx::size::Hint const ,  ::efl::input::Interface const ,  ::efl::ui::Base const > operator&() const { return {this}; }
   /// @endcond
};
} 
}
namespace edje { 
struct Object : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl::Animator)
   , EO_CXX_INHERIT( ::efl::Container)
   , EO_CXX_INHERIT( ::efl::File)
   , EO_CXX_INHERIT( ::efl::Gfx)
   , EO_CXX_INHERIT( ::efl::Interface)
   , EO_CXX_INHERIT( ::efl::Loop_User)
   , EO_CXX_INHERIT( ::efl::Object)
   , EO_CXX_INHERIT( ::efl::Observer)
   , EO_CXX_INHERIT( ::efl::Part)
   , EO_CXX_INHERIT( ::efl ::canvas::Group)
   , EO_CXX_INHERIT( ::efl ::canvas::Object)
   , EO_CXX_INHERIT( ::efl ::canvas ::group::Clipped)
   , EO_CXX_INHERIT( ::efl ::gfx::Map)
   , EO_CXX_INHERIT( ::efl ::gfx::Stack)
   , EO_CXX_INHERIT( ::efl ::gfx ::size::Hint)
   , EO_CXX_INHERIT( ::efl ::input::Interface)
   , EO_CXX_INHERIT( ::efl ::ui::Base)
{
   explicit Object( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Object(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Object(Object const& other) = default;
   Object(Object&& other) = default;
   Object& operator=(Object const& other) = default;
   Object& operator=(Object&& other) = default;
   Object()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Object( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Object(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<bool>::type animation_get() const;
   ::efl::eolian::return_traits<void>::type animation_set( ::efl::eolian::in_traits<bool>::type on) const;
   ::efl::eolian::return_traits<bool>::type play_get() const;
   ::efl::eolian::return_traits<void>::type play_set( ::efl::eolian::in_traits<bool>::type play) const;
   ::efl::eolian::return_traits<Edje_Perspective const&>::type perspective_get() const;
   ::efl::eolian::return_traits<void>::type perspective_set( ::efl::eolian::in_traits<Edje_Perspective const&>::type ps) const;
   ::efl::eolian::return_traits<double>::type transition_duration_factor_get() const;
   ::efl::eolian::return_traits<void>::type transition_duration_factor_set( ::efl::eolian::in_traits<double>::type scale) const;
   ::efl::eolian::return_traits<Efl_Image_Load_Error>::type load_error_get() const;
   ::efl::eolian::return_traits<bool>::type calc_update_hints_get() const;
   ::efl::eolian::return_traits<void>::type calc_update_hints_set( ::efl::eolian::in_traits<bool>::type update) const;
   ::efl::eolian::return_traits<void>::type group_size_min_get( ::efl::eolian::out_traits<int>::type minw,  ::efl::eolian::out_traits<int>::type minh) const;
   ::efl::eolian::return_traits<void>::type group_size_max_get( ::efl::eolian::out_traits<int>::type maxw,  ::efl::eolian::out_traits<int>::type maxh) const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type group_data_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type key) const;
   ::efl::eolian::return_traits<bool>::type global_color_class_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type color_class,  ::efl::eolian::in_traits<Edje_Color_Class_Mode>::type mode,  ::efl::eolian::out_traits<int>::type r,  ::efl::eolian::out_traits<int>::type g,  ::efl::eolian::out_traits<int>::type b,  ::efl::eolian::out_traits<int>::type a) const;
   ::efl::eolian::return_traits<bool>::type global_color_class_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type color_class,  ::efl::eolian::in_traits<Edje_Color_Class_Mode>::type mode,  ::efl::eolian::in_traits<int>::type r,  ::efl::eolian::in_traits<int>::type g,  ::efl::eolian::in_traits<int>::type b,  ::efl::eolian::in_traits<int>::type a) const;
   ::efl::eolian::return_traits<bool>::type color_class_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type color_class,  ::efl::eolian::in_traits<Edje_Color_Class_Mode>::type mode,  ::efl::eolian::out_traits<int>::type r,  ::efl::eolian::out_traits<int>::type g,  ::efl::eolian::out_traits<int>::type b,  ::efl::eolian::out_traits<int>::type a) const;
   ::efl::eolian::return_traits<bool>::type color_class_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type color_class,  ::efl::eolian::in_traits<Edje_Color_Class_Mode>::type mode,  ::efl::eolian::in_traits<int>::type r,  ::efl::eolian::in_traits<int>::type g,  ::efl::eolian::in_traits<int>::type b,  ::efl::eolian::in_traits<int>::type a) const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type color_class_description_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type color_class) const;
   ::efl::eolian::return_traits<bool>::type text_class_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type text_class,  ::efl::eolian::out_traits< ::efl::eina::string_view>::type font,  ::efl::eolian::out_traits<int>::type size) const;
   ::efl::eolian::return_traits<bool>::type text_class_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type text_class,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type font,  ::efl::eolian::in_traits<int>::type size) const;
   ::efl::eolian::return_traits<bool>::type size_class_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type size_class,  ::efl::eolian::out_traits<int>::type minw,  ::efl::eolian::out_traits<int>::type minh,  ::efl::eolian::out_traits<int>::type maxw,  ::efl::eolian::out_traits<int>::type maxh) const;
   ::efl::eolian::return_traits<bool>::type size_class_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type size_class,  ::efl::eolian::in_traits<int>::type minw,  ::efl::eolian::in_traits<int>::type minh,  ::efl::eolian::in_traits<int>::type maxw,  ::efl::eolian::in_traits<int>::type maxh) const;
   ::efl::eolian::return_traits<void>::type text_change_cb_set( ::efl::eolian::in_traits<Edje_Text_Change_Cb>::type func,  ::efl::eolian::in_traits<void*>::type data) const;
   ::efl::eolian::return_traits<Edje_Text_Autocapital_Type>::type part_text_autocapital_type_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   ::efl::eolian::return_traits<void>::type part_text_autocapital_type_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Text_Autocapital_Type>::type autocapital_type) const;
   ::efl::eolian::return_traits<bool>::type part_text_prediction_allow_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   ::efl::eolian::return_traits<void>::type part_text_prediction_allow_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<bool>::type prediction) const;
   ::efl::eolian::return_traits<void>::type item_provider_set( ::efl::eolian::in_traits<Edje_Item_Provider_Cb>::type func,  ::efl::eolian::in_traits<void*>::type data) const;
   ::efl::eolian::return_traits<void>::type part_text_select_allow_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<bool>::type allow) const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type part_text_selection_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   ::efl::eolian::return_traits<void*>::type part_text_imf_context_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   ::efl::eolian::return_traits<Edje_Input_Hints>::type part_text_input_hint_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   ::efl::eolian::return_traits<void>::type part_text_input_hint_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Input_Hints>::type input_hints) const;
   ::efl::eolian::return_traits<void>::type part_text_input_panel_imdata_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<void*>::type data,  ::efl::eolian::out_traits<int>::type len) const;
   ::efl::eolian::return_traits<void>::type part_text_input_panel_imdata_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<void const*>::type data,  ::efl::eolian::in_traits<int>::type len) const;
   ::efl::eolian::return_traits<Edje_Input_Panel_Layout>::type part_text_input_panel_layout_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   ::efl::eolian::return_traits<void>::type part_text_input_panel_layout_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Input_Panel_Layout>::type layout) const;
   ::efl::eolian::return_traits<Edje_Input_Panel_Lang>::type part_text_input_panel_language_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   ::efl::eolian::return_traits<void>::type part_text_input_panel_language_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Input_Panel_Lang>::type lang) const;
   ::efl::eolian::return_traits<int>::type part_text_input_panel_layout_variation_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   ::efl::eolian::return_traits<void>::type part_text_input_panel_layout_variation_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<int>::type variation) const;
   ::efl::eolian::return_traits<bool>::type part_text_input_panel_enabled_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   ::efl::eolian::return_traits<void>::type part_text_input_panel_enabled_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<bool>::type enabled) const;
   ::efl::eolian::return_traits<bool>::type part_text_input_panel_return_key_disabled_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   ::efl::eolian::return_traits<void>::type part_text_input_panel_return_key_disabled_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<bool>::type disabled) const;
   ::efl::eolian::return_traits<Edje_Input_Panel_Return_Key_Type>::type part_text_input_panel_return_key_type_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   ::efl::eolian::return_traits<void>::type part_text_input_panel_return_key_type_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<Edje_Input_Panel_Return_Key_Type>::type return_key_type) const;
   ::efl::eolian::return_traits<bool>::type part_text_input_panel_show_on_demand_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   ::efl::eolian::return_traits<void>::type part_text_input_panel_show_on_demand_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits<bool>::type ondemand) const;
   ::efl::eolian::return_traits<void>::type part_text_prediction_hint_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type prediction_hint) const;
   ::efl::eolian::return_traits< ::efl::input::Device>::type seat_get( ::efl::eolian::in_traits< ::efl::eina::stringshare>::type name) const;
   ::efl::eolian::return_traits< ::efl::eina::stringshare>::type seat_name_get( ::efl::eolian::in_traits< ::efl::input::Device>::type device) const;
   ::efl::eolian::return_traits<bool>::type preload( ::efl::eolian::in_traits<bool>::type cancel) const;
   ::efl::eolian::return_traits<void>::type size_min_calc( ::efl::eolian::out_traits<int>::type minw,  ::efl::eolian::out_traits<int>::type minh) const;
   ::efl::eolian::return_traits<void>::type size_min_restricted_calc( ::efl::eolian::out_traits<int>::type minw,  ::efl::eolian::out_traits<int>::type minh,  ::efl::eolian::in_traits<int>::type restrictedw,  ::efl::eolian::in_traits<int>::type restrictedh) const;
   ::efl::eolian::return_traits<bool>::type parts_extends_calc( ::efl::eolian::out_traits<int>::type x,  ::efl::eolian::out_traits<int>::type y,  ::efl::eolian::out_traits<int>::type w,  ::efl::eolian::out_traits<int>::type h) const;
   ::efl::eolian::return_traits<void>::type calc_force() const;
   ::efl::eolian::return_traits<int>::type calc_freeze() const;
   ::efl::eolian::return_traits<int>::type calc_thaw() const;
   ::efl::eolian::return_traits<void>::type message_send( ::efl::eolian::in_traits<int>::type id,  ::efl::eolian::in_traits< ::efl::eina::value_view const>::type msg) const;
   ::efl::eolian::return_traits<void>::type signal_callback_add( ::efl::eolian::in_traits< ::efl::eina::string_view>::type emission,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type source,  ::efl::eolian::in_traits<Edje_Signal_Cb>::type func,  ::efl::eolian::in_traits<void*>::type data) const;
   ::efl::eolian::return_traits<void*>::type signal_callback_del( ::efl::eolian::in_traits< ::efl::eina::string_view>::type emission,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type source,  ::efl::eolian::in_traits<Edje_Signal_Cb>::type func,  ::efl::eolian::in_traits<void*>::type data) const;
   ::efl::eolian::return_traits<void>::type signal_emit( ::efl::eolian::in_traits< ::efl::eina::string_view>::type emission,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type source) const;
   ::efl::eolian::return_traits<void>::type message_signal_process( ::efl::eolian::in_traits< ::efl::eina::optional<bool>>::type recurse) const;
   ::efl::eolian::return_traits<bool>::type color_class_clear() const;
   ::efl::eolian::return_traits<void>::type color_class_del( ::efl::eolian::in_traits< ::efl::eina::string_view>::type color_class) const;
   ::efl::eolian::return_traits<void>::type text_class_del( ::efl::eolian::in_traits< ::efl::eina::string_view>::type text_class) const;
   ::efl::eolian::return_traits<void>::type size_class_del( ::efl::eolian::in_traits< ::efl::eina::string_view>::type size_class) const;
   ::efl::eolian::return_traits< ::efl::eina::iterator< ::efl::eina::string_view>>::type access_part_iterate() const;
   ::efl::eolian::return_traits<bool>::type part_exists( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   ::efl::eolian::return_traits<void>::type part_text_select_begin( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   ::efl::eolian::return_traits<void>::type part_text_select_abort( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   ::efl::eolian::return_traits<void>::type part_text_select_extend( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   ::efl::eolian::return_traits<void>::type part_text_select_all( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   ::efl::eolian::return_traits<void>::type part_text_select_none( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   ::efl::eolian::return_traits<void>::type part_text_imf_context_reset( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   ::efl::eolian::return_traits<void>::type part_text_input_panel_show( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   ::efl::eolian::return_traits<void>::type part_text_input_panel_hide( ::efl::eolian::in_traits< ::efl::eina::string_view>::type part) const;
   static Efl_Class const* _eo_class()
   {
      return EDJE_OBJECT_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   static struct recalc_event
   {
      static Efl_Event_Description const* description()
      { return EDJE_OBJECT_EVENT_RECALC; }
      typedef void parameter_type;
   } const recalc_event;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Object,  ::efl::Animator,  ::efl::Container,  ::efl::File,  ::efl::Gfx,  ::efl::Interface,  ::efl::Loop_User,  ::efl::Object,  ::efl::Observer,  ::efl::Part,  ::efl::canvas::Group,  ::efl::canvas::Object,  ::efl::canvas::group::Clipped,  ::efl::gfx::Map,  ::efl::gfx::Stack,  ::efl::gfx::size::Hint,  ::efl::input::Interface,  ::efl::ui::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Object const ,  ::efl::Animator const ,  ::efl::Container const ,  ::efl::File const ,  ::efl::Gfx const ,  ::efl::Interface const ,  ::efl::Loop_User const ,  ::efl::Object const ,  ::efl::Observer const ,  ::efl::Part const ,  ::efl::canvas::Group const ,  ::efl::canvas::Object const ,  ::efl::canvas::group::Clipped const ,  ::efl::gfx::Map const ,  ::efl::gfx::Stack const ,  ::efl::gfx::size::Hint const ,  ::efl::input::Interface const ,  ::efl::ui::Base const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Object) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Object>::value, "");
} 
#endif
