#ifndef EFL_TEXT_FONT_EO_HH
#define EFL_TEXT_FONT_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_text_font.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
namespace efl { namespace text { 
struct Font;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::text::Font> : ::std::true_type {}; } }
namespace efl { namespace text { 
struct Font;
} } 

namespace eo_cxx {
namespace efl { namespace text { 
struct Font {
   ::efl::eolian::return_traits<void>::type font_get( ::efl::eolian::out_traits< ::efl::eina::string_view>::type font,  ::efl::eolian::out_traits<int>::type size) const;
   ::efl::eolian::return_traits<void>::type font_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type font,  ::efl::eolian::in_traits<int>::type size) const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type font_source_get() const;
   ::efl::eolian::return_traits<void>::type font_source_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type font_source) const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type font_fallbacks_get() const;
   ::efl::eolian::return_traits<void>::type font_fallbacks_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type font_fallbacks) const;
   ::efl::eolian::return_traits<Efl_Text_Font_Weight>::type font_weight_get() const;
   ::efl::eolian::return_traits<void>::type font_weight_set( ::efl::eolian::in_traits<Efl_Text_Font_Weight>::type font_weight) const;
   ::efl::eolian::return_traits<Efl_Text_Font_Slant>::type font_slant_get() const;
   ::efl::eolian::return_traits<void>::type font_slant_set( ::efl::eolian::in_traits<Efl_Text_Font_Slant>::type style) const;
   ::efl::eolian::return_traits<Efl_Text_Font_Width>::type font_width_get() const;
   ::efl::eolian::return_traits<void>::type font_width_set( ::efl::eolian::in_traits<Efl_Text_Font_Width>::type width) const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type font_lang_get() const;
   ::efl::eolian::return_traits<void>::type font_lang_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type lang) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_TEXT_FONT_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::text::Font() const;
   operator ::efl::text::Font&();
   operator ::efl::text::Font const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Font> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Font const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace text { 
struct Font : ::efl::eo::concrete
{
   explicit Font( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Font(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Font(Font const& other) = default;
   Font(Font&& other) = default;
   Font& operator=(Font const& other) = default;
   Font& operator=(Font&& other) = default;
   Font()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Font( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Font(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<void>::type font_get( ::efl::eolian::out_traits< ::efl::eina::string_view>::type font,  ::efl::eolian::out_traits<int>::type size) const;
   ::efl::eolian::return_traits<void>::type font_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type font,  ::efl::eolian::in_traits<int>::type size) const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type font_source_get() const;
   ::efl::eolian::return_traits<void>::type font_source_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type font_source) const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type font_fallbacks_get() const;
   ::efl::eolian::return_traits<void>::type font_fallbacks_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type font_fallbacks) const;
   ::efl::eolian::return_traits<Efl_Text_Font_Weight>::type font_weight_get() const;
   ::efl::eolian::return_traits<void>::type font_weight_set( ::efl::eolian::in_traits<Efl_Text_Font_Weight>::type font_weight) const;
   ::efl::eolian::return_traits<Efl_Text_Font_Slant>::type font_slant_get() const;
   ::efl::eolian::return_traits<void>::type font_slant_set( ::efl::eolian::in_traits<Efl_Text_Font_Slant>::type style) const;
   ::efl::eolian::return_traits<Efl_Text_Font_Width>::type font_width_get() const;
   ::efl::eolian::return_traits<void>::type font_width_set( ::efl::eolian::in_traits<Efl_Text_Font_Width>::type width) const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type font_lang_get() const;
   ::efl::eolian::return_traits<void>::type font_lang_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type lang) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_TEXT_FONT_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Font> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Font const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Font) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Font>::value, "");
} } 
#endif
