#ifndef EFL_UI_BASE_EO_HH
#define EFL_UI_BASE_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_ui_base.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
namespace efl { namespace ui { 
struct Base;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::Base> : ::std::true_type {}; } }
namespace efl { namespace ui { 
struct Base;
} } 

namespace eo_cxx {
namespace efl { namespace ui { 
struct Base {
   ::efl::eolian::return_traits<bool>::type mirrored_get() const;
   ::efl::eolian::return_traits<void>::type mirrored_set( ::efl::eolian::in_traits<bool>::type rtl) const;
   ::efl::eolian::return_traits<bool>::type mirrored_automatic_get() const;
   ::efl::eolian::return_traits<void>::type mirrored_automatic_set( ::efl::eolian::in_traits<bool>::type automatic) const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type language_get() const;
   ::efl::eolian::return_traits<void>::type language_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type language) const;
   ::efl::eolian::return_traits<double>::type scale_get() const;
   ::efl::eolian::return_traits<void>::type scale_set( ::efl::eolian::in_traits<double>::type scale) const;
   ::efl::eolian::return_traits<double>::type base_scale_get() const;
   static Efl_Class const* _eo_class()
   {
      return EFL_UI_BASE_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::ui::Base() const;
   operator ::efl::ui::Base&();
   operator ::efl::ui::Base const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Base const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace ui { 
struct Base : ::efl::eo::concrete
{
   explicit Base( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Base(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Base(Base const& other) = default;
   Base(Base&& other) = default;
   Base& operator=(Base const& other) = default;
   Base& operator=(Base&& other) = default;
   Base()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Base( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Base(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<bool>::type mirrored_get() const;
   ::efl::eolian::return_traits<void>::type mirrored_set( ::efl::eolian::in_traits<bool>::type rtl) const;
   ::efl::eolian::return_traits<bool>::type mirrored_automatic_get() const;
   ::efl::eolian::return_traits<void>::type mirrored_automatic_set( ::efl::eolian::in_traits<bool>::type automatic) const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type language_get() const;
   ::efl::eolian::return_traits<void>::type language_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type language) const;
   ::efl::eolian::return_traits<double>::type scale_get() const;
   ::efl::eolian::return_traits<void>::type scale_set( ::efl::eolian::in_traits<double>::type scale) const;
   ::efl::eolian::return_traits<double>::type base_scale_get() const;
   static Efl_Class const* _eo_class()
   {
      return EFL_UI_BASE_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Base const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Base) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Base>::value, "");
} } 
#endif
