#ifndef EFL_GFX_MAP_EO_HH
#define EFL_GFX_MAP_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_gfx.eo.h"
#include "efl_gfx_map.eo.h"
#include "efl_interface.eo.h"
#include "efl_object.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_gfx.eo.hh"
#include "efl_interface.eo.hh"
#include "efl_object.eo.hh"
namespace efl { namespace gfx { 
struct Map;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::gfx::Map> : ::std::true_type {}; } }
namespace efl { namespace gfx { 
struct Map;
} } 
namespace efl { 
struct Interface;
} 
namespace efl { 
struct Object;
} 
namespace efl { 
struct Gfx;
} 

namespace eo_cxx {
namespace efl { namespace gfx { 
struct Map {
   ::efl::eolian::return_traits<int>::type map_point_count_get() const;
   ::efl::eolian::return_traits<void>::type map_point_count_set( ::efl::eolian::in_traits<int>::type count) const;
   ::efl::eolian::return_traits<bool>::type map_clockwise_get() const;
   ::efl::eolian::return_traits<bool>::type map_smooth_get() const;
   ::efl::eolian::return_traits<void>::type map_smooth_set( ::efl::eolian::in_traits<bool>::type smooth) const;
   ::efl::eolian::return_traits<bool>::type map_alpha_get() const;
   ::efl::eolian::return_traits<void>::type map_alpha_set( ::efl::eolian::in_traits<bool>::type alpha) const;
   ::efl::eolian::return_traits<void>::type map_coord_absolute_get( ::efl::eolian::in_traits<int>::type idx,  ::efl::eolian::out_traits<double>::type x,  ::efl::eolian::out_traits<double>::type y,  ::efl::eolian::out_traits<double>::type z) const;
   ::efl::eolian::return_traits<void>::type map_coord_absolute_set( ::efl::eolian::in_traits<int>::type idx,  ::efl::eolian::in_traits<double>::type x,  ::efl::eolian::in_traits<double>::type y,  ::efl::eolian::in_traits<double>::type z) const;
   ::efl::eolian::return_traits<void>::type map_uv_get( ::efl::eolian::in_traits<int>::type idx,  ::efl::eolian::out_traits<double>::type u,  ::efl::eolian::out_traits<double>::type v) const;
   ::efl::eolian::return_traits<void>::type map_uv_set( ::efl::eolian::in_traits<int>::type idx,  ::efl::eolian::in_traits<double>::type u,  ::efl::eolian::in_traits<double>::type v) const;
   ::efl::eolian::return_traits<void>::type map_color_get( ::efl::eolian::in_traits<int>::type idx,  ::efl::eolian::out_traits<int>::type r,  ::efl::eolian::out_traits<int>::type g,  ::efl::eolian::out_traits<int>::type b,  ::efl::eolian::out_traits<int>::type a) const;
   ::efl::eolian::return_traits<void>::type map_color_set( ::efl::eolian::in_traits<int>::type idx,  ::efl::eolian::in_traits<int>::type r,  ::efl::eolian::in_traits<int>::type g,  ::efl::eolian::in_traits<int>::type b,  ::efl::eolian::in_traits<int>::type a) const;
   ::efl::eolian::return_traits<bool>::type map_has() const;
   ::efl::eolian::return_traits<void>::type map_reset() const;
   ::efl::eolian::return_traits<void>::type translate( ::efl::eolian::in_traits<double>::type dx,  ::efl::eolian::in_traits<double>::type dy,  ::efl::eolian::in_traits<double>::type dz) const;
   ::efl::eolian::return_traits<void>::type rotate( ::efl::eolian::in_traits<double>::type degrees,  ::efl::eolian::in_traits< ::efl::Gfx>::type pivot,  ::efl::eolian::in_traits<double>::type cx,  ::efl::eolian::in_traits<double>::type cy) const;
   ::efl::eolian::return_traits<void>::type rotate_3d( ::efl::eolian::in_traits<double>::type dx,  ::efl::eolian::in_traits<double>::type dy,  ::efl::eolian::in_traits<double>::type dz,  ::efl::eolian::in_traits< ::efl::Gfx>::type pivot,  ::efl::eolian::in_traits<double>::type cx,  ::efl::eolian::in_traits<double>::type cy,  ::efl::eolian::in_traits<double>::type cz) const;
   ::efl::eolian::return_traits<void>::type rotate_quat( ::efl::eolian::in_traits<double>::type qx,  ::efl::eolian::in_traits<double>::type qy,  ::efl::eolian::in_traits<double>::type qz,  ::efl::eolian::in_traits<double>::type qw,  ::efl::eolian::in_traits< ::efl::Gfx>::type pivot,  ::efl::eolian::in_traits<double>::type cx,  ::efl::eolian::in_traits<double>::type cy,  ::efl::eolian::in_traits<double>::type cz) const;
   ::efl::eolian::return_traits<void>::type zoom( ::efl::eolian::in_traits<double>::type zoomx,  ::efl::eolian::in_traits<double>::type zoomy,  ::efl::eolian::in_traits< ::efl::Gfx>::type pivot,  ::efl::eolian::in_traits<double>::type cx,  ::efl::eolian::in_traits<double>::type cy) const;
   ::efl::eolian::return_traits<void>::type lightning_3d( ::efl::eolian::in_traits< ::efl::Gfx>::type pivot,  ::efl::eolian::in_traits<double>::type lx,  ::efl::eolian::in_traits<double>::type ly,  ::efl::eolian::in_traits<double>::type lz,  ::efl::eolian::in_traits<int>::type lr,  ::efl::eolian::in_traits<int>::type lg,  ::efl::eolian::in_traits<int>::type lb,  ::efl::eolian::in_traits<int>::type ar,  ::efl::eolian::in_traits<int>::type ag,  ::efl::eolian::in_traits<int>::type ab) const;
   ::efl::eolian::return_traits<void>::type perspective_3d( ::efl::eolian::in_traits< ::efl::Gfx>::type pivot,  ::efl::eolian::in_traits<double>::type px,  ::efl::eolian::in_traits<double>::type py,  ::efl::eolian::in_traits<double>::type z0,  ::efl::eolian::in_traits<double>::type foc) const;
   ::efl::eolian::return_traits<void>::type rotate_absolute( ::efl::eolian::in_traits<double>::type degrees,  ::efl::eolian::in_traits<double>::type cx,  ::efl::eolian::in_traits<double>::type cy) const;
   ::efl::eolian::return_traits<void>::type rotate_3d_absolute( ::efl::eolian::in_traits<double>::type dx,  ::efl::eolian::in_traits<double>::type dy,  ::efl::eolian::in_traits<double>::type dz,  ::efl::eolian::in_traits<double>::type cx,  ::efl::eolian::in_traits<double>::type cy,  ::efl::eolian::in_traits<double>::type cz) const;
   ::efl::eolian::return_traits<void>::type rotate_quat_absolute( ::efl::eolian::in_traits<double>::type qx,  ::efl::eolian::in_traits<double>::type qy,  ::efl::eolian::in_traits<double>::type qz,  ::efl::eolian::in_traits<double>::type qw,  ::efl::eolian::in_traits<double>::type cx,  ::efl::eolian::in_traits<double>::type cy,  ::efl::eolian::in_traits<double>::type cz) const;
   ::efl::eolian::return_traits<void>::type zoom_absolute( ::efl::eolian::in_traits<double>::type zoomx,  ::efl::eolian::in_traits<double>::type zoomy,  ::efl::eolian::in_traits<double>::type cx,  ::efl::eolian::in_traits<double>::type cy) const;
   ::efl::eolian::return_traits<void>::type lightning_3d_absolute( ::efl::eolian::in_traits<double>::type lx,  ::efl::eolian::in_traits<double>::type ly,  ::efl::eolian::in_traits<double>::type lz,  ::efl::eolian::in_traits<int>::type lr,  ::efl::eolian::in_traits<int>::type lg,  ::efl::eolian::in_traits<int>::type lb,  ::efl::eolian::in_traits<int>::type ar,  ::efl::eolian::in_traits<int>::type ag,  ::efl::eolian::in_traits<int>::type ab) const;
   ::efl::eolian::return_traits<void>::type perspective_3d_absolute( ::efl::eolian::in_traits<double>::type px,  ::efl::eolian::in_traits<double>::type py,  ::efl::eolian::in_traits<double>::type z0,  ::efl::eolian::in_traits<double>::type foc) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_GFX_MAP_MIXIN;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::gfx::Map() const;
   operator ::efl::gfx::Map&();
   operator ::efl::gfx::Map const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Map,  ::efl::Interface,  ::efl::Object> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Map const ,  ::efl::Interface const ,  ::efl::Object const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace gfx { 
struct Map : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl::Interface)
   , EO_CXX_INHERIT( ::efl::Object)
{
   explicit Map( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Map(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Map(Map const& other) = default;
   Map(Map&& other) = default;
   Map& operator=(Map const& other) = default;
   Map& operator=(Map&& other) = default;
   Map()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Map( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Map(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<int>::type map_point_count_get() const;
   ::efl::eolian::return_traits<void>::type map_point_count_set( ::efl::eolian::in_traits<int>::type count) const;
   ::efl::eolian::return_traits<bool>::type map_clockwise_get() const;
   ::efl::eolian::return_traits<bool>::type map_smooth_get() const;
   ::efl::eolian::return_traits<void>::type map_smooth_set( ::efl::eolian::in_traits<bool>::type smooth) const;
   ::efl::eolian::return_traits<bool>::type map_alpha_get() const;
   ::efl::eolian::return_traits<void>::type map_alpha_set( ::efl::eolian::in_traits<bool>::type alpha) const;
   ::efl::eolian::return_traits<void>::type map_coord_absolute_get( ::efl::eolian::in_traits<int>::type idx,  ::efl::eolian::out_traits<double>::type x,  ::efl::eolian::out_traits<double>::type y,  ::efl::eolian::out_traits<double>::type z) const;
   ::efl::eolian::return_traits<void>::type map_coord_absolute_set( ::efl::eolian::in_traits<int>::type idx,  ::efl::eolian::in_traits<double>::type x,  ::efl::eolian::in_traits<double>::type y,  ::efl::eolian::in_traits<double>::type z) const;
   ::efl::eolian::return_traits<void>::type map_uv_get( ::efl::eolian::in_traits<int>::type idx,  ::efl::eolian::out_traits<double>::type u,  ::efl::eolian::out_traits<double>::type v) const;
   ::efl::eolian::return_traits<void>::type map_uv_set( ::efl::eolian::in_traits<int>::type idx,  ::efl::eolian::in_traits<double>::type u,  ::efl::eolian::in_traits<double>::type v) const;
   ::efl::eolian::return_traits<void>::type map_color_get( ::efl::eolian::in_traits<int>::type idx,  ::efl::eolian::out_traits<int>::type r,  ::efl::eolian::out_traits<int>::type g,  ::efl::eolian::out_traits<int>::type b,  ::efl::eolian::out_traits<int>::type a) const;
   ::efl::eolian::return_traits<void>::type map_color_set( ::efl::eolian::in_traits<int>::type idx,  ::efl::eolian::in_traits<int>::type r,  ::efl::eolian::in_traits<int>::type g,  ::efl::eolian::in_traits<int>::type b,  ::efl::eolian::in_traits<int>::type a) const;
   ::efl::eolian::return_traits<bool>::type map_has() const;
   ::efl::eolian::return_traits<void>::type map_reset() const;
   ::efl::eolian::return_traits<void>::type translate( ::efl::eolian::in_traits<double>::type dx,  ::efl::eolian::in_traits<double>::type dy,  ::efl::eolian::in_traits<double>::type dz) const;
   ::efl::eolian::return_traits<void>::type rotate( ::efl::eolian::in_traits<double>::type degrees,  ::efl::eolian::in_traits< ::efl::Gfx>::type pivot,  ::efl::eolian::in_traits<double>::type cx,  ::efl::eolian::in_traits<double>::type cy) const;
   ::efl::eolian::return_traits<void>::type rotate_3d( ::efl::eolian::in_traits<double>::type dx,  ::efl::eolian::in_traits<double>::type dy,  ::efl::eolian::in_traits<double>::type dz,  ::efl::eolian::in_traits< ::efl::Gfx>::type pivot,  ::efl::eolian::in_traits<double>::type cx,  ::efl::eolian::in_traits<double>::type cy,  ::efl::eolian::in_traits<double>::type cz) const;
   ::efl::eolian::return_traits<void>::type rotate_quat( ::efl::eolian::in_traits<double>::type qx,  ::efl::eolian::in_traits<double>::type qy,  ::efl::eolian::in_traits<double>::type qz,  ::efl::eolian::in_traits<double>::type qw,  ::efl::eolian::in_traits< ::efl::Gfx>::type pivot,  ::efl::eolian::in_traits<double>::type cx,  ::efl::eolian::in_traits<double>::type cy,  ::efl::eolian::in_traits<double>::type cz) const;
   ::efl::eolian::return_traits<void>::type zoom( ::efl::eolian::in_traits<double>::type zoomx,  ::efl::eolian::in_traits<double>::type zoomy,  ::efl::eolian::in_traits< ::efl::Gfx>::type pivot,  ::efl::eolian::in_traits<double>::type cx,  ::efl::eolian::in_traits<double>::type cy) const;
   ::efl::eolian::return_traits<void>::type lightning_3d( ::efl::eolian::in_traits< ::efl::Gfx>::type pivot,  ::efl::eolian::in_traits<double>::type lx,  ::efl::eolian::in_traits<double>::type ly,  ::efl::eolian::in_traits<double>::type lz,  ::efl::eolian::in_traits<int>::type lr,  ::efl::eolian::in_traits<int>::type lg,  ::efl::eolian::in_traits<int>::type lb,  ::efl::eolian::in_traits<int>::type ar,  ::efl::eolian::in_traits<int>::type ag,  ::efl::eolian::in_traits<int>::type ab) const;
   ::efl::eolian::return_traits<void>::type perspective_3d( ::efl::eolian::in_traits< ::efl::Gfx>::type pivot,  ::efl::eolian::in_traits<double>::type px,  ::efl::eolian::in_traits<double>::type py,  ::efl::eolian::in_traits<double>::type z0,  ::efl::eolian::in_traits<double>::type foc) const;
   ::efl::eolian::return_traits<void>::type rotate_absolute( ::efl::eolian::in_traits<double>::type degrees,  ::efl::eolian::in_traits<double>::type cx,  ::efl::eolian::in_traits<double>::type cy) const;
   ::efl::eolian::return_traits<void>::type rotate_3d_absolute( ::efl::eolian::in_traits<double>::type dx,  ::efl::eolian::in_traits<double>::type dy,  ::efl::eolian::in_traits<double>::type dz,  ::efl::eolian::in_traits<double>::type cx,  ::efl::eolian::in_traits<double>::type cy,  ::efl::eolian::in_traits<double>::type cz) const;
   ::efl::eolian::return_traits<void>::type rotate_quat_absolute( ::efl::eolian::in_traits<double>::type qx,  ::efl::eolian::in_traits<double>::type qy,  ::efl::eolian::in_traits<double>::type qz,  ::efl::eolian::in_traits<double>::type qw,  ::efl::eolian::in_traits<double>::type cx,  ::efl::eolian::in_traits<double>::type cy,  ::efl::eolian::in_traits<double>::type cz) const;
   ::efl::eolian::return_traits<void>::type zoom_absolute( ::efl::eolian::in_traits<double>::type zoomx,  ::efl::eolian::in_traits<double>::type zoomy,  ::efl::eolian::in_traits<double>::type cx,  ::efl::eolian::in_traits<double>::type cy) const;
   ::efl::eolian::return_traits<void>::type lightning_3d_absolute( ::efl::eolian::in_traits<double>::type lx,  ::efl::eolian::in_traits<double>::type ly,  ::efl::eolian::in_traits<double>::type lz,  ::efl::eolian::in_traits<int>::type lr,  ::efl::eolian::in_traits<int>::type lg,  ::efl::eolian::in_traits<int>::type lb,  ::efl::eolian::in_traits<int>::type ar,  ::efl::eolian::in_traits<int>::type ag,  ::efl::eolian::in_traits<int>::type ab) const;
   ::efl::eolian::return_traits<void>::type perspective_3d_absolute( ::efl::eolian::in_traits<double>::type px,  ::efl::eolian::in_traits<double>::type py,  ::efl::eolian::in_traits<double>::type z0,  ::efl::eolian::in_traits<double>::type foc) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_GFX_MAP_MIXIN;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Map,  ::efl::Interface,  ::efl::Object> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Map const ,  ::efl::Interface const ,  ::efl::Object const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Map) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Map>::value, "");
} } 
#endif
