#ifndef EVAS_CANVAS3D_CAMERA_EO_HH
#define EVAS_CANVAS3D_CAMERA_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_object.eo.h"
#include "evas_canvas3d_camera.eo.h"
#include "evas_canvas3d_node.eo.h"
#include "evas_canvas3d_object.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_object.eo.hh"
#include "evas_canvas3d_node.eo.hh"
#include "evas_canvas3d_object.eo.hh"
namespace evas { namespace canvas3d { 
struct Camera;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::evas::canvas3d::Camera> : ::std::true_type {}; } }
namespace evas { namespace canvas3d { 
struct Camera;
} } 
namespace evas { namespace canvas3d { 
struct Object;
} } 
namespace efl { 
struct Object;
} 
namespace evas { namespace canvas3d { 
struct Node;
} } 

namespace eo_cxx {
namespace evas { namespace canvas3d { 
struct Camera {
   ::efl::eolian::return_traits<void>::type projection_matrix_set( ::efl::eolian::in_traits<Evas_Real const&>::type matrix) const;
   ::efl::eolian::return_traits<void>::type projection_matrix_get( ::efl::eolian::out_traits<Evas_Real>::type matrix) const;
   ::efl::eolian::return_traits<void>::type projection_perspective_set( ::efl::eolian::in_traits<Evas_Real>::type fovy,  ::efl::eolian::in_traits<Evas_Real>::type aspect,  ::efl::eolian::in_traits<Evas_Real>::type dnear,  ::efl::eolian::in_traits<Evas_Real>::type dfar) const;
   ::efl::eolian::return_traits<void>::type projection_frustum_set( ::efl::eolian::in_traits<Evas_Real>::type left,  ::efl::eolian::in_traits<Evas_Real>::type right,  ::efl::eolian::in_traits<Evas_Real>::type bottom,  ::efl::eolian::in_traits<Evas_Real>::type top,  ::efl::eolian::in_traits<Evas_Real>::type dnear,  ::efl::eolian::in_traits<Evas_Real>::type dfar) const;
   ::efl::eolian::return_traits<void>::type projection_ortho_set( ::efl::eolian::in_traits<Evas_Real>::type left,  ::efl::eolian::in_traits<Evas_Real>::type right,  ::efl::eolian::in_traits<Evas_Real>::type bottom,  ::efl::eolian::in_traits<Evas_Real>::type top,  ::efl::eolian::in_traits<Evas_Real>::type dnear,  ::efl::eolian::in_traits<Evas_Real>::type dfar) const;
   ::efl::eolian::return_traits<bool>::type node_visible_get( ::efl::eolian::in_traits< ::evas::canvas3d::Node>::type camera_node,  ::efl::eolian::in_traits< ::evas::canvas3d::Node>::type node,  ::efl::eolian::in_traits<Evas_Canvas3D_Frustum_Mode>::type key) const;
   static Efl_Class const* _eo_class()
   {
      return EVAS_CANVAS3D_CAMERA_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::evas::canvas3d::Camera() const;
   operator ::evas::canvas3d::Camera&();
   operator ::evas::canvas3d::Camera const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Camera,  ::efl::Object,  ::evas::canvas3d::Object> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Camera const ,  ::efl::Object const ,  ::evas::canvas3d::Object const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace evas { namespace canvas3d { 
struct Camera : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl::Object)
   , EO_CXX_INHERIT( ::evas ::canvas3d::Object)
{
   explicit Camera( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Camera(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Camera(Camera const& other) = default;
   Camera(Camera&& other) = default;
   Camera& operator=(Camera const& other) = default;
   Camera& operator=(Camera&& other) = default;
   Camera()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Camera( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Camera(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<void>::type projection_matrix_set( ::efl::eolian::in_traits<Evas_Real const&>::type matrix) const;
   ::efl::eolian::return_traits<void>::type projection_matrix_get( ::efl::eolian::out_traits<Evas_Real>::type matrix) const;
   ::efl::eolian::return_traits<void>::type projection_perspective_set( ::efl::eolian::in_traits<Evas_Real>::type fovy,  ::efl::eolian::in_traits<Evas_Real>::type aspect,  ::efl::eolian::in_traits<Evas_Real>::type dnear,  ::efl::eolian::in_traits<Evas_Real>::type dfar) const;
   ::efl::eolian::return_traits<void>::type projection_frustum_set( ::efl::eolian::in_traits<Evas_Real>::type left,  ::efl::eolian::in_traits<Evas_Real>::type right,  ::efl::eolian::in_traits<Evas_Real>::type bottom,  ::efl::eolian::in_traits<Evas_Real>::type top,  ::efl::eolian::in_traits<Evas_Real>::type dnear,  ::efl::eolian::in_traits<Evas_Real>::type dfar) const;
   ::efl::eolian::return_traits<void>::type projection_ortho_set( ::efl::eolian::in_traits<Evas_Real>::type left,  ::efl::eolian::in_traits<Evas_Real>::type right,  ::efl::eolian::in_traits<Evas_Real>::type bottom,  ::efl::eolian::in_traits<Evas_Real>::type top,  ::efl::eolian::in_traits<Evas_Real>::type dnear,  ::efl::eolian::in_traits<Evas_Real>::type dfar) const;
   ::efl::eolian::return_traits<bool>::type node_visible_get( ::efl::eolian::in_traits< ::evas::canvas3d::Node>::type camera_node,  ::efl::eolian::in_traits< ::evas::canvas3d::Node>::type node,  ::efl::eolian::in_traits<Evas_Canvas3D_Frustum_Mode>::type key) const;
   static Efl_Class const* _eo_class()
   {
      return EVAS_CANVAS3D_CAMERA_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Camera,  ::efl::Object,  ::evas::canvas3d::Object> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Camera const ,  ::efl::Object const ,  ::evas::canvas3d::Object const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Camera) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Camera>::value, "");
} } 
#endif
